
//---------------------------------------------------------------------------------------------
// Places Utilities extensions
//---------------------------------------------------------------------------------------------

tabutils._PlacesUtilsExt = function() {
	PlacesUtils.getItemIdForTag = function getItemIdForTag(aTag) {
		var tagId = -1;
		var tagsResultNode = this.getFolderContents(this.tagsFolderId).root;
		for (var i = 0, cc = tagsResultNode.childCount; i < cc; i++) {
			var node = tagsResultNode.getChild(i);
			if (node.title.toLowerCase() == aTag.toLowerCase()) {
				tagId = node.itemId;
				break;
			}
		}
		tagsResultNode.containerOpen = false;
		return tagId;
	};

	PlacesUtils.getItemIdForTaggedURI = function getItemIdForTaggedURI(aURI, aTag) {
	var tagId = this.getItemIdForTag(aTag);
	if (tagId == -1)
		return -1;

	var bookmarkIds = this.bookmarks.getBookmarkIdsForURI(aURI, {});
	for (let bookmarkId of bookmarkIds) {
		if (this.bookmarks.getFolderIdForItem(bookmarkId) == tagId)
			return bookmarkId;
		}
		return -1;
	};

	PlacesUtils.removeTag = function removeTag(aTag) {
		this.tagging.getURIsForTag(aTag).forEach(
			function(aURI) {
				this.tagging.untagURI(aURI, [aTag]);
			}
		, this);
	};
};
