
// "All Tabs" popup
//-----------------------------------------------
//гбǩҳ˵
tabutils._allTabsPopup = function() {
	function $() { //TODO: this is repeated in the section above! (Tab context menu)
		return document.getElementById.apply(document, arguments);
	}

	var allTabsPopup = gBrowser.mTabContainer.mAllTabsPopup;
	if (!allTabsPopup)
		return;

	Array.slice($("alltabs-popup-template").childNodes).forEach(
		function(aItem) {
			allTabsPopup.appendChild(aItem);
		}
	);

	allTabsPopup.setAttribute("oncommand", "event.stopPropagation();");
	allTabsPopup.setAttribute("onclick", "if (event.button == 0) event.stopPropagation();");
	tabutils.addEventListener(allTabsPopup.parentNode, "popupshowing", 
		function(event) {
			while (allTabsPopup.firstChild && allTabsPopup.firstChild.tab) //Bug 714594 (Fx12), 716271 (Fx12)
				allTabsPopup.removeChild(allTabsPopup.firstChild);

			var lastVisibleItem = null;
			for (let item = allTabsPopup.firstChild; item && !item.tab; item = item.nextSibling) {
				if (item.localName == "menuseparator")
					item.hidden = !lastVisibleItem || lastVisibleItem.localName == "menuseparator";

				if (!item.hidden && !item.collapsed)
					lastVisibleItem = item;
			}

			var item = $("context_showAllTabs");
			item.setAttribute("checked", gBrowser.mTabContainer.getAttribute("showAllTabs"));
			item.setAttribute("disabled", gBrowser.mTabContainer.orient == "vertical");

			var tabs = gBrowser.allTabs;
			var item = $("context_readAllTabs");
			var checked = tabs.every(
				function(aTab) 
					aTab.getAttribute("unread") != "true"
			);
			item.setAttribute("label", checked ? item.getAttribute("label_checked") : item.getAttribute("label_unchecked"));
			item.setAttribute("checked", checked);
			item.setAttribute("disabled", tabs.every(
				function(aTab) aTab.selected
			));

			[
				["context_protectAllTabs", ["protected"]],
				["context_lockAllTabs", ["locked"]],
				["context_faviconizeAllTabs", ["faviconized"]]
			].forEach(
				function([aId, aAttrs]) {
					$(aId).setAttribute("checked", tabs.every(
						function(aTab) 
							aAttrs.every(
								function(aAttr) 
									aTab.hasAttribute(aAttr)
							)
					));
				}
			);
		}
		, true
	);

	if ("MenuEdit" in window) { //Make allTabsPopup editable by MenuEdit
		TU_hookCode("MenuEdit.getEditableMenus", /(?=return menus;)/, 
			"menus['" + allTabsPopup.id + "'] = gBrowser.mTabContainer.mAllTabsPopup.parentNode.tooltipText;"
		);
	}
};
